<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/communication/TIGLCommunicationSysMessage.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_3a3fb334f8e32f8b75f30f6eb3cfdf6e.html">src</a></li><li class="navelem"><a class="el" href="dir_41b3ccb19a6d365afc2b4a7bbd034095.html">standard</a></li><li class="navelem"><a class="el" href="dir_e5e605185631aa34c675c5c984a4ce63.html">modules</a></li><li class="navelem"><a class="el" href="dir_fb7ca0dcf3f8c533686c530ed50d41b5.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">TIGLCommunicationSysMessage.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="SysMessage_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#ifndef SYSMESSAGE_HPP_</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define SYSMESSAGE_HPP_</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#define IS_SM_MASK  (1 &lt;&lt; 7)        // highest bit of destDevice contains isSysMessage bit</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define SYS_MASK    0x7f        // this assumes that destDevice is stored as UI</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;types.h&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;{</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    ADD_VERTEX = 0, </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    REMOVE_VERTEX, </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment">//  ADD_EDGE, </span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment">//  REMOVE_EDGE, </span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    GET_VERTEX_POS, <span class="comment">// request a position of a given vertex</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    INFO_VERTEX_POS, <span class="comment">// provides the device position of a given vertex</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    VERTEX_NOT_EXIST, </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    ERR_RCVR_NOT_EXIST, </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    UNDEFINED_MESSAGE, </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    AGGREGATE_INFO, </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    DEV_IDLE, </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    HALT</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;}SYS_MESSAGE_CODE;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">inline</span> SYS_MESSAGE_CODE getMessageCode(byte * buf)</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;{</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    SYS_MESSAGE_CODE code = (SYS_MESSAGE_CODE)*(buf++);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keywordflow">return</span> code;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classSysMessage.html">   61</a></span>&#160;<span class="keyword">class </span><a class="code" href="classSysMessage.html">TIGLCommunicationSysMessage</a></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;{</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> MESSAGE_TYPE&gt;</div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classSysMessage.html#a714c2c29b7a0982e570bed858fa261c5">   72</a></span>&#160;    <a class="code" href="classSysMessage.html#a714c2c29b7a0982e570bed858fa261c5">TIGLCommunicationSysMessage</a>(SYS_MESSAGE_CODE code, uint32 dev, MESSAGE_TYPE * message)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    {</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        messageCode = code;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        otherDevice = dev;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        byte * messageBytes = (byte *)message;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordflow">for</span>(uint32 i = 0 ; i &lt; <span class="keyword">sizeof</span>(MESSAGE_TYPE); i++)</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            messageBody.push_back(*(messageBytes++));</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    }</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classSysMessage.html#ab2f4c7f10c8af52821351fbeca332104">   87</a></span>&#160;<span class="comment"></span>    <a class="code" href="classSysMessage.html#ab2f4c7f10c8af52821351fbeca332104">TIGLCommunicationSysMessage</a>(SYS_MESSAGE_CODE code, uint32 dev)</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    {</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        messageCode = code;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        otherDevice = dev;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    }</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="classSysMessage.html#a7acf59b14d347dfbcdd3e49d78e919d4">   98</a></span>&#160;<span class="comment"></span>    <a class="code" href="classSysMessage.html#a7acf59b14d347dfbcdd3e49d78e919d4">TIGLCommunicationSysMessage</a>()</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    {</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        messageCode = UNDEFINED_MESSAGE;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    }</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    ~<a class="code" href="classSysMessage.html">TIGLCommunicationSysMessage</a>(){}</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="classSysMessage.html#aa67168daf8848766380190abd3bdcdf9">  109</a></span>&#160;<span class="comment"></span>    SYS_MESSAGE_CODE        <a class="code" href="classSysMessage.html#aa67168daf8848766380190abd3bdcdf9">messageCode</a>;</div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classSysMessage.html#afdcad6f9ad4937d063dbc15c00f7ad10">  111</a></span>&#160;    vector&lt;byte&gt;            <a class="code" href="classSysMessage.html#afdcad6f9ad4937d063dbc15c00f7ad10">messageBody</a>;</div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classSysMessage.html#a5a39e4c51c1f52b8f8eb8f95c67fa44d">  113</a></span>&#160;    uint32                  <a class="code" href="classSysMessage.html#a5a39e4c51c1f52b8f8eb8f95c67fa44d">otherDevice</a>;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="classSysMessage.html#ab542414656e44685e12dd8955ead1f73">  118</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> SYS_MESSAGE_CODE <a class="code" href="classSysMessage.html#ab542414656e44685e12dd8955ead1f73">getMessageCode</a>(){<span class="keywordflow">return</span> messageCode;}</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classSysMessage.html#a6fb72a79bfd4c5ed0051ca3904971266">  121</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classSysMessage.html#a6fb72a79bfd4c5ed0051ca3904971266">hasBody</a>(){<span class="keywordflow">return</span> (messageBody.size() &gt; 0);}</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classSysMessage.html#ac5e50b022ba2184cf3ce8f1f97c1799c">  124</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classSysMessage.html#ac5e50b022ba2184cf3ce8f1f97c1799c">getSizeInBytes</a>(){<span class="keywordflow">return</span> messageBody.size();}</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00127"></a><span class="lineno"><a class="line" href="classSysMessage.html#a48b715ecbcc05699ef7583a9f1a81499">  127</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classSysMessage.html#a48b715ecbcc05699ef7583a9f1a81499">getDst</a>(){<span class="keywordflow">return</span> otherDevice;}</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="classSysMessage.html#ac6c22ba14d44e08991b6433dea15d4fe">  133</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classSysMessage.html#ac6c22ba14d44e08991b6433dea15d4fe">pack</a>(byte * buf)</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="comment">// putting the message code and the system message flag</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        byte firstByte = (uint8)messageCode;<span class="comment">// | IS_SM_MASK;</span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        *(buf++) = firstByte;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        uint32 messageSize = getSizeInBytes()+1;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keywordflow">if</span>(messageSize &gt; 1)</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        {</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            <span class="keywordflow">for</span>(vector&lt;byte&gt;::iterator it = messageBody.begin(); it != messageBody.end(); ++it)</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                *(buf++) = *it;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordflow">return</span> messageSize;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="classSysMessage.html#a54804da8f905137a39ecb496b4746bb8">  151</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classSysMessage.html#a54804da8f905137a39ecb496b4746bb8">unpack</a>(byte * buf, uint32 numBytes)</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    {</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        messageCode = (SYS_MESSAGE_CODE)(*(buf++));</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">if</span>(numBytes &gt; 1)</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        {</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keywordflow">for</span>(uint32 i = 1 ; i &lt; numBytes ; i++)</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                messageBody.push_back(*(buf++));</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    }</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> MESSAGE_TYPE&gt;</div>
<div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="classSysMessage.html#abb76b90df5f97135b53a2a815163f8cc">  168</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classSysMessage.html#abb76b90df5f97135b53a2a815163f8cc">readMessageBody</a>(MESSAGE_TYPE * message)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordflow">if</span>(messageBody.size() != <span class="keyword">sizeof</span>(MESSAGE_TYPE))</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        byte * p = (byte *) message;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordflow">for</span>(vector&lt;byte&gt;::iterator it= messageBody.begin(); it != messageBody.end(); ++it)</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        {</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            *(p++) = *it;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        }</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;};</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="keyword">inline</span> <span class="keywordtype">bool</span> isSysMessage(byte * buf);</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* SYSMESSAGE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classSysMessage_html_aa67168daf8848766380190abd3bdcdf9"><div class="ttname"><a href="classSysMessage.html#aa67168daf8848766380190abd3bdcdf9">TIGLCommunicationSysMessage::messageCode</a></div><div class="ttdeci">SYS_MESSAGE_CODE messageCode</div><div class="ttdoc">code of the system message </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:109</div></div>
<div class="ttc" id="classSysMessage_html_ac6c22ba14d44e08991b6433dea15d4fe"><div class="ttname"><a href="classSysMessage.html#ac6c22ba14d44e08991b6433dea15d4fe">TIGLCommunicationSysMessage::pack</a></div><div class="ttdeci">uint32 pack(byte *buf)</div><div class="ttdoc">packing the system message into bytes the packed message contains the message code and the message bo...</div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:133</div></div>
<div class="ttc" id="classSysMessage_html_a54804da8f905137a39ecb496b4746bb8"><div class="ttname"><a href="classSysMessage.html#a54804da8f905137a39ecb496b4746bb8">TIGLCommunicationSysMessage::unpack</a></div><div class="ttdeci">void unpack(byte *buf, uint32 numBytes)</div><div class="ttdoc">unpacking a system message to the object fields </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:151</div></div>
<div class="ttc" id="classSysMessage_html_ab542414656e44685e12dd8955ead1f73"><div class="ttname"><a href="classSysMessage.html#ab542414656e44685e12dd8955ead1f73">TIGLCommunicationSysMessage::getMessageCode</a></div><div class="ttdeci">SYS_MESSAGE_CODE getMessageCode()</div><div class="ttdoc">returns the system message code </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:118</div></div>
<div class="ttc" id="classSysMessage_html_a6fb72a79bfd4c5ed0051ca3904971266"><div class="ttname"><a href="classSysMessage.html#a6fb72a79bfd4c5ed0051ca3904971266">TIGLCommunicationSysMessage::hasBody</a></div><div class="ttdeci">bool hasBody()</div><div class="ttdoc">checks if the message has a body </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:121</div></div>
<div class="ttc" id="classSysMessage_html_ab2f4c7f10c8af52821351fbeca332104"><div class="ttname"><a href="classSysMessage.html#ab2f4c7f10c8af52821351fbeca332104">TIGLCommunicationSysMessage::TIGLCommunicationSysMessage</a></div><div class="ttdeci">TIGLCommunicationSysMessage(SYS_MESSAGE_CODE code, uint32 dev)</div><div class="ttdoc">overloaded constructor for system messages that do not have a body </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:87</div></div>
<div class="ttc" id="classSysMessage_html_ac5e50b022ba2184cf3ce8f1f97c1799c"><div class="ttname"><a href="classSysMessage.html#ac5e50b022ba2184cf3ce8f1f97c1799c">TIGLCommunicationSysMessage::getSizeInBytes</a></div><div class="ttdeci">uint32 getSizeInBytes()</div><div class="ttdoc">reading the variable-size message body </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:124</div></div>
<div class="ttc" id="classSysMessage_html_a48b715ecbcc05699ef7583a9f1a81499"><div class="ttname"><a href="classSysMessage.html#a48b715ecbcc05699ef7583a9f1a81499">TIGLCommunicationSysMessage::getDst</a></div><div class="ttdeci">uint32 getDst()</div><div class="ttdoc">reading teh destination device </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:127</div></div>
<div class="ttc" id="classSysMessage_html_abb76b90df5f97135b53a2a815163f8cc"><div class="ttname"><a href="classSysMessage.html#abb76b90df5f97135b53a2a815163f8cc">TIGLCommunicationSysMessage::readMessageBody</a></div><div class="ttdeci">bool readMessageBody(MESSAGE_TYPE *message)</div><div class="ttdoc">converting a packed format to a customized message format </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:168</div></div>
<div class="ttc" id="classSysMessage_html_a714c2c29b7a0982e570bed858fa261c5"><div class="ttname"><a href="classSysMessage.html#a714c2c29b7a0982e570bed858fa261c5">TIGLCommunicationSysMessage::TIGLCommunicationSysMessage</a></div><div class="ttdeci">TIGLCommunicationSysMessage(SYS_MESSAGE_CODE code, uint32 dev, MESSAGE_TYPE *message)</div><div class="ttdoc">constructor set the fields of the system message </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:72</div></div>
<div class="ttc" id="classSysMessage_html_afdcad6f9ad4937d063dbc15c00f7ad10"><div class="ttname"><a href="classSysMessage.html#afdcad6f9ad4937d063dbc15c00f7ad10">TIGLCommunicationSysMessage::messageBody</a></div><div class="ttdeci">vector&lt; byte &gt; messageBody</div><div class="ttdoc">message body in bytes </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:111</div></div>
<div class="ttc" id="classSysMessage_html_a7acf59b14d347dfbcdd3e49d78e919d4"><div class="ttname"><a href="classSysMessage.html#a7acf59b14d347dfbcdd3e49d78e919d4">TIGLCommunicationSysMessage::TIGLCommunicationSysMessage</a></div><div class="ttdeci">TIGLCommunicationSysMessage()</div><div class="ttdoc">overloaded constructor for an system message empty message to be filled by the unpack procedure ...</div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:98</div></div>
<div class="ttc" id="classSysMessage_html_a5a39e4c51c1f52b8f8eb8f95c67fa44d"><div class="ttname"><a href="classSysMessage.html#a5a39e4c51c1f52b8f8eb8f95c67fa44d">TIGLCommunicationSysMessage::otherDevice</a></div><div class="ttdeci">uint32 otherDevice</div><div class="ttdoc">the destination device </div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:113</div></div>
<div class="ttc" id="classSysMessage_html"><div class="ttname"><a href="classSysMessage.html">TIGLCommunicationSysMessage</a></div><div class="ttdef"><b>Definition:</b> TIGLCommunicationSysMessage.hpp:61</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 3 2014 16:46:36 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
